@ECHO OFF
REM	%1	training data
REM	%2	test data
REM	%3	target metric label
REM	%4	neighborhood size
REM	%5	metric label of neighborhoods' labels
REM	%6	prefix of the ouputted files
REM	Similarity Computation Algorithms
REM		StandardizedValueBasedCosineSimilarity
REM		NormalizedValueBasedCosineSimilarity
REM		OrderBasedCosineSimilarity
REM		StandardizedValueBasedAdjustedCosineSimilarityWithAverage
REM		NormalizedValueBasedAdjustedCosineSimilarityWithAverage
REM		OrderBasedAdjustedCosineSimilarityWithAverage
REM		StandardizedValueBasedAdjustedCosineSimilarityWithMedian
REM		NormalizedValueBasedAdjustedCosineSimilarityWithMedian
REM		OrderBasedAdjustedCosineSimilarityWithMedian
REM		StandardizedValueBasedCorrelationCoefficientWithAverage
REM		NormalizedValueBasedCorrelationCoefficientWithAverage
REM		OrderBasedCorrelationCoefficientWithAverage
REM		StandardizedValueBasedCorrelationCoefficientWithMedian
REM		NormalizedValueBasedCorrelationCoefficientWithMedian
REM		OrderBasedCorrelationCoefficientWithMedian
REM		StandardizedValueBasedRankCorrelation
REM		NormalizedValueBasedRankCorrelation
REM		OrderBasedRankCorrelation
REM		SequenceBasedSimilarityWithStandardizedValue
REM		SequenceBasedSimilarityWithNormalizedValue
REM		SequenceBasedSimilarityWithOrder
REM	Prediction Algorithms
REM		SimpleWeightedSum
REM		AdjustedWeightedSumWithAverageOnMetric
REM		AdjustedWeightedSumWithMedianOnMetric
REM		SimpleStandardizedValueBasedWeightedSum
REM		AdjustedStandardizedValueBasedWeightedSumWithAverageOnFile
REM		AdjustedStandardizedValueBasedWeightedSumWithMedianOnFile
REM		AdjustedStandardizedValueBasedWeightedSumWithAverageOnMetric
REM		AdjustedStandardizedValueBasedWeightedSumWithMedianOnMetric
REM		SimpleNormalizedValueBasedWeightedSum
REM		AdjustedNormalizedValueBasedWeightedSumWithAverageOnFile
REM		AdjustedNormalizedValueBasedWeightedSumWithMedianOnFile
REM		AdjustedNormalizedValueBasedWeightedSumWithAverageOnMetric
REM		AdjustedNormalizedValueBasedWeightedSumWithMedianOnMetric
REM		SimpleOrderBasedWeightedSum
REM		AdjustedOrderBasedWeightedSumWithAverageOnFile
REM		AdjustedOrderBasedWeightedSumWithMedianOnFile
REM		AdjustedOrderBasedWeightedSumWithAverageOnMetric
REM		AdjustedOrderBasedWeightedSumWithMedianOnMetric
REM		AmplifiedWeightedSumWithAveragedMultiplier
REM		AmplifiedWeightedSumWithMedianOfMultiplier
REM		AmplifiedStandardizedValueBasedWeightedSumWithAveragedMultiplier
REM		AmplifiedStandardizedValueBasedWeightedSumWithMedianOfMultiplier
REM		AmplifiedNormalizedValueBasedWeightedSumWithAveragedMultiplier
REM		AmplifiedNormalizedValueBasedWeightedSumWithMedianOfMultiplier
REM		AmplifiedOrderBasedWeightedSumWithAveragedMultiplier
REM		AmplifiedOrderBasedWeightedSumWithMedianOfMultiplier
REM	sample commandline	> docfbe.exe training=learningdata_sample.csv test=testdata_sample.csv target="oO" nsize=10 similarity=NormalizedValueBasedCosineSimilarity prediction=SimpleWeightedSum nlabel=t@C nsims sdstrb output=test.csv

IF "%1"=="" GOTO HELP
IF "%2"=="" GOTO NOPARAM
IF "%3"=="" GOTO NOPARAM
IF "%4"=="" GOTO NOPARAM
IF "%5"=="" GOTO NOPARAM
IF "%6"=="" GOTO NOPARAM

FOR %%S IN (StandardizedValueBasedCosineSimilarity NormalizedValueBasedCosineSimilarity OrderBasedCosineSimilarity StandardizedValueBasedAdjustedCosineSimilarityWithAverage NormalizedValueBasedAdjustedCosineSimilarityWithAverage OrderBasedAdjustedCosineSimilarityWithAverage StandardizedValueBasedAdjustedCosineSimilarityWithMedian NormalizedValueBasedAdjustedCosineSimilarityWithMedian OrderBasedAdjustedCosineSimilarityWithMedian StandardizedValueBasedCorrelationCoefficientWithAverage NormalizedValueBasedCorrelationCoefficientWithAverage OrderBasedCorrelationCoefficientWithAverage StandardizedValueBasedCorrelationCoefficientWithMedian NormalizedValueBasedCorrelationCoefficientWithMedian OrderBasedCorrelationCoefficientWithMedian StandardizedValueBasedRankCorrelation NormalizedValueBasedRankCorrelation OrderBasedRankCorrelation SequenceBasedSimilarityWithStandardizedValue SequenceBasedSimilarityWithNormalizedValue SequenceBasedSimilarityWithOrder) DO FOR %%P IN (SimpleWeightedSum AdjustedWeightedSumWithAverageOnMetric AdjustedWeightedSumWithMedianOnMetric SimpleStandardizedValueBasedWeightedSum AdjustedStandardizedValueBasedWeightedSumWithAverageOnFile AdjustedStandardizedValueBasedWeightedSumWithMedianOnFile AdjustedStandardizedValueBasedWeightedSumWithAverageOnMetric AdjustedStandardizedValueBasedWeightedSumWithMedianOnMetric SimpleNormalizedValueBasedWeightedSum AdjustedNormalizedValueBasedWeightedSumWithAverageOnFile AdjustedNormalizedValueBasedWeightedSumWithMedianOnFile AdjustedNormalizedValueBasedWeightedSumWithAverageOnMetric AdjustedNormalizedValueBasedWeightedSumWithMedianOnMetric SimpleOrderBasedWeightedSum AdjustedOrderBasedWeightedSumWithAverageOnFile AdjustedOrderBasedWeightedSumWithMedianOnFile AdjustedOrderBasedWeightedSumWithAverageOnMetric AdjustedOrderBasedWeightedSumWithMedianOnMetric AmplifiedWeightedSumWithAveragedMultiplier AmplifiedWeightedSumWithMedianOfMultiplier AmplifiedStandardizedValueBasedWeightedSumWithAveragedMultiplier AmplifiedStandardizedValueBasedWeightedSumWithMedianOfMultiplier AmplifiedNormalizedValueBasedWeightedSumWithAveragedMultiplier AmplifiedNormalizedValueBasedWeightedSumWithMedianOfMultiplier AmplifiedOrderBasedWeightedSumWithAveragedMultiplier AmplifiedOrderBasedWeightedSumWithMedianOfMultiplier) DO docfbe.exe training=%1 test=%2 target=%3 nsize=%4 nlabel=%5 nsims sdstrb output=%6#%%S+%%P.csv similarity=%%S prediction=%%P

ECHO All Processes are Completed!!

GOTO END

:NOPARAM
ECHO Parameter Error!

:HELP
ECHO docfbe_all (training data) (test data) (target metric label) (neighborhood size) (metric label of neighborhoods' labels) (prefix of the ouputted files)

:END
